/*****************************************
 * 232.NET multiprocesorova komunikcia *
 *****************************************/

#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rtx51.h>
#include <dsw.h>

#define	 Token				'^'		//Malo by to byt 0x5E='^'
#define	 MyAddrNet		0x00	//Definujem adresu siete 8051
#define	 MyAddr51			0xAB	//Definujem moju adresu, dostanem ju z .ini debuggera-a
#define	 MyBroadcast	0xFF	//Definujem Broadcast-s address-u
#define  WaitForEver	0xFF	//Cakam donekonecna ...
#define  MBXS					0x00	//Cislo mailbox-u kde sa odosielaju data

#define  SYSTEM  			0x00
#define  SERIAL	 			0x01
#define  COM     			0x02

extern	void Reset51(void);

#define	SizeOfPacketData 32

typedef xdata struct  																		//Musi byt deklarovana a pouzivana ako je to uvedene v tomto tvare, inac spravne nefunguje !!!
{
 unsigned char Preamble,Dst,Src;
 unsigned int Size; 
 unsigned char Data[SizeOfPacketData]; 
 unsigned char Crc;
}
Packet51;

#define NumMemBlocks	5																		//Definujem [n] pamatovych blokov ...
#define	SizeMemBlock	(sizeof(Packet51))
#define	SizeMemPool		(NumMemBlocks*(2+SizeMemBlock))			//(Header+sizeof(Packet51)*n)

xdata volatile Packet51 Packet;														//Definoval som prazdny packet, naplnim ho v inom task-u, struktura nesmie byt optimalizovana kompilatorom ...
xdata unsigned char MemoryPool[SizeMemPool] _at_ 0x0000;	//MemoryPool je niekedy lepsie definovat na pevnej adrese ale uVision robi problemy pri simulacii ...
xdata Packet51 *ReceivedMessage, *ReceivedRS232;					//Ukazovatel na prijate znaky z mailbox-u a na prijate znaky z RS232 
xdata unsigned int *MessageToSend, *MessageToRecv;				//Rozne nadefinovane buffer-e vysielaneho a prijimaneho packet-u

enum state {OFF=0, ON=1};
enum lists {preamblepkt=0, dstpkt=1, srcpkt=2, sizeofpkthi=3, sizeofpktlo=4, headerpkt=5, crcpkt=(sizeof(Packet51)-1), endpkt=sizeof(Packet51), sizedatapkt=SizeOfPacketData, mempoolpkt=sizeof(MemoryPool)};

void Com(void) _task_ COM _priority_ 0
{
 signed char RtxCompletion;
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT,WaitForEver,NULL))
	  {
		 case	TMO_EVENT	:	
		 case	SIG_EVENT	:	RtxCompletion=0x00;	break;								//Prisli mi data z RS232 ...
		 case	INT_EVENT	:	break;
		}
	}
}

unsigned char Check_CRC(unsigned char *Block) reentrant					//Volam rutinu z viacerych taskov ...
{
 unsigned int i;
 unsigned char tmp;
 tmp=0x00;
 for(i=0x00; i<(sizeof(Packet51)-1); i++) tmp+=Block[i];				//Scitam vsetky polozky packetu
 tmp=~tmp; tmp+=1;
 return(tmp);
}
/*
void Vytvor_Packet(unsigned char Dst, Src, unsigned char *Data, Packet51 *BlockPacket, int SizeData)
{
 BlockPacket->Preamble=Token;
 BlockPacket->Dst=Dst;
 BlockPacket->Src=Src;
 memset(&BlockPacket->Data,NULL,sizeof(BlockPacket->Data));					//Datovu cast Packetu vynulujem ...
 memcpy(&BlockPacket->Data,Data,SizeData);
 BlockPacket->Crc=Check_CRC((unsigned char xdata*)BlockPacket);
}
*/
bit recv=OFF,send=OFF;

void Serial(void) _task_ SERIAL _priority_ 0
{
 signed char RtxCompletion;
 idata unsigned int iin,iout;
 unsigned char Znak;
 TMOD|=0x20;
 PCON|=0x80;
 S0CON|=0x50;
 TH1=0xFB;																													//Nastavim prenosovu rychlost 19200bps
 TR1=1; //TI=1;																											//Je tu potrebne len pre printf(), putchar() !!!
 if((MessageToSend=os_get_block(SizeMemBlock))!=NULL);							//Blok pamati rezervujem pre task ktory je pouzity v SERIAL
 if((MessageToRecv=os_get_block(SizeMemBlock))!=NULL) ReceivedRS232=(unsigned int)MessageToRecv;	//Adresa prijimacieho buffera v pool-e sa inicializuje ...
 RtxCompletion=os_attach_interrupt(4);															//Simultanny prijem a vysielanie je riadene prerusenim od serioveho kanala ...
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+MBXS,WaitForEver,(unsigned int xdata*)&ReceivedMessage))	//Prijem packetu z mailbox-u, prijimam len adresu na strukturu ...
	  {
		 case	TMO_EVENT	:	iin=0x0000;																									//Ak nepride prerusenie od prijmu dat nulujem pocitadlo aby som sa nezacyklil ...
											memset(ReceivedRS232,NULL,sizeof(Packet51));								//Vynulujem prijimaci buffer ReceiveRS232 ...
											break;																				
		 case	MSG_EVENT	:	os_send_signal(SERIAL); break;															//Nepotrebujem pocitat CRC prijateho packetu a predsa to posielam v ramci 8051, aby som poslal signal sam sebe na spracovanie ... !!!
											//if(Check_CRC((unsigned char xdata*)ReceivedMessage)==(ReceivedMessage->Crc)) os_send_signal(SERIAL); break;	//Vypocitam CRC prijateho packetu a musia byt rovnake aby som poslal signal sam sebe na spracovanie ... !!!
											break;
		 case	SIG_EVENT	: send=ON; iout=preamblepkt;
											S0BUF=(ReceivedMessage->Preamble);
                      os_wait(K_TMO,0,NULL);																			//Aby stihli vsetky systemy zaregistrovat pritomnost Tokenu '^' na sieti, maju niekolko ms...
											break;
		 case	INT_EVENT	:	if(TI&RI) recv=send=ON;																			//Ak som tu, tak mam prijem a vysielanie sucasne co potvrdzuje sucasne prijimanie a vysielanie sucasne  ...
											if(RI)
											 {
												RI=0;	Znak=S0BUF;	recv=ON;																//Pritomnost tokenu signalizuje data na zbernici
												if(Znak==Token) 
												 {
												  iin=0x0000;
													memset(ReceivedRS232,NULL,sizeof(Packet51));						//Vynulujem prijimaci buffer ReceiveRS232, pretoze obsahuje stare hodnoty ...
												 }	
												switch(iin++)
												 {
													case	preamblepkt	:	ReceivedRS232->Preamble=Znak; break;//Ak je to token tak sa nastavim na zaciatok dat ...
													case	dstpkt			:	ReceivedRS232->Dst=Znak; break;
													case	srcpkt			:	ReceivedRS232->Src=Znak; break;
													case	sizeofpkthi	: ReceivedRS232->Size=256*Znak; break;
													case	sizeofpktlo	:	ReceivedRS232->Size+=Znak; break;
													case	crcpkt			:	ReceivedRS232->Crc=Znak;
																							if(Check_CRC((unsigned char xdata*)ReceivedRS232)==(ReceivedRS232->Crc))
																							 {
																								recv=OFF;
																								//RtxCompletion=os_free_block(SizeMemBlock,MessageToRecv);	//Zrusim prijimaci buffer ...
																								switch(ReceivedRS232->Dst)				//Komu je packet urceny, vykonam akciu ???
																								 {
																								  case	MyAddrNet		:	break;
																									case	MyAddr51		:
																									case	MyBroadcast	:	RtxCompletion=os_send_signal(COM); break;
																									default						:	memset(ReceivedRS232,NULL,sizeof(Packet51)); break;	//Nie su to data pre mna, mazem prijimaci buffer ...
																								 }
																							 }	
																							break;
													default						:	ReceivedRS232->Data[iin-(headerpkt+1)]=Znak; break;		//Pokracujem v prijme dat ...
												 }
												}
											 if(TI)
												{
												 TI=0;
												 switch(++iout)
													{
													 case	preamblepkt	: 																											//Tu by som sa nemal nikdy dostat, lebo som uz poslal Preamble ...
													 case	dstpkt			:	S0BUF=(ReceivedMessage->Dst); break;
													 case	srcpkt			:	S0BUF=(ReceivedMessage->Src); break;
													 case	sizeofpkthi	:	S0BUF=(high(ReceivedMessage->Size)); break;
													 case	sizeofpktlo	:	S0BUF=(low(ReceivedMessage->Size)); break;
													 case	crcpkt			: S0BUF=(ReceivedMessage->Crc); break;
													 case	endpkt			:	//RtxCompletion=os_free_block(SizeMemBlock,MessageToSend);	//RtxCompletion==NULL je OK ak uvolnim pamat ...
																							send=OFF;
																							break;//Nevymazavat, musi to tu byt !!!
													 default					: S0BUF=(ReceivedMessage->Data[iout-headerpkt]); break;	//Poslem vsetky data ...
													}
												 }										//Odosielanie znaku nemusim riesit, ide prerusenim os_attach_interrupt(4) ...
		}
	}
}

//xdata Packet51 AAA;

void System(void) _task_ SYSTEM _priority_ 0
{
 signed char RtxCompletion; 
 RtxCompletion=os_set_slice(15360); 
 RtxCompletion=os_create_pool(SizeMemBlock,MemoryPool,SizeMemPool); //Vytvorim MemoryPool v pamati XRAM pre datove struktury ... 
 RtxCompletion=os_create_task(SERIAL);
 RtxCompletion=os_create_task(COM);
 while(1)
  {
//*****************************************************************************************************************************************************
//	 AAA=Packet;
//	 Vytvor_Packet(1,2,"!!! Diversant Software !!!",(Packet51 xdata*)&AAA,sizeof("!!! Diversant Software !!!"));
//	 Vytvor_Packet((char)rand(),(char)rand(),"!!! Diversant Software !!!",(Packet51 xdata*)&AAA,sizeof("!!! Diversant Software !!!"));
//	 Packet=AAA;
//*****************************************************************************************************************************************************	 
//   if((MessageToSend=os_get_block(SizeMemBlock))!=NULL)							//Vytvorim packet ...
	 if(MessageToSend!=NULL)																						//Vytvorim packet ...
	  {
		 Packet.Preamble=Token;
		 Packet.Dst=(unsigned char)rand();
		 Packet.Src=(unsigned char)rand();
		 Packet.Size=sizeof(Packet.Data);
		 strcpy(Packet.Data,"!!! Diversant Software !!!\r\n");
		 Packet.Crc=Check_CRC((unsigned char xdata*)&Packet);
		 memcpy(MessageToSend,&Packet,sizeof(Packet));									//Pamat je rezervovana a pozem kopirovat blok na odoslanie ...
//		 while(recv==ON) RtxCompletion=os_wait(K_TMO,1,NULL);						//Je prijem dat cez RS232 tak sa stopnem na chvilu s vysielanim ...
		 RtxCompletion=os_send_message(MBXS,(unsigned int xdata*)MessageToSend,WaitForEver);	//Posielam adresu datovej struktury cez mailbox ...
		}
//   Packet.Crc=Check_CRC((unsigned char xdata*)MessageToSend);     	//Vypocitam CRC skopirovaneho packetu a musia byt rovnake !!!
	 RtxCompletion=os_wait(K_TMO,250,NULL);
//	 RtxCompletion=os_free_block(SizeMemBlock,MessageToSend);					//RtxCompletion==NULL je OK ak uvolnim pamat v tasku SERIAL !!!
//	 os_delete_task(SYSTEM);
  }
}

void main(void)
{
 signed char RtxCompletion;
 RtxCompletion=os_start_system(SYSTEM);
}